<script setup lang="ts">
import { type Ref, ref, inject, provide } from 'vue'
import { useUserStore } from '@/stores/user'
import { routeLocationKey } from 'vue-router'
import router from '@/router'
import { useAuthStore } from '@/stores/auth'

const userStore = useUserStore()
const authStore = useAuthStore()
const form = ref(false)
const enterEmail = ref('noppa@dc.th')
const enterPassword = ref('Pass@1234')
const loading = ref(false)
const visible = ref(false)
const required = (v: string) => !!v || 'Field is required'

function onSubmit() {
  if (!form.value) return
  loading.value = true
  setTimeout(() => {
    loading.value = false
    authStore.login(enterEmail.value, enterPassword.value)
    if (userStore.currentUser != null) {
      console.log('UserStore:', userStore.currentUser)
    }
  }, 2000)
}
</script>

<template>
  <div>
    <div class="d-flex align-center justify-center">
      <v-avatar
        image="src\image\logo\logo1 (1).png"
        size="120"
        alt="Background Image"
        class="background-image"
      ></v-avatar>
    </div>

    <v-card class="mx-auto pa-12 pb-8 my-auto" elevation="8" max-width="448" rounded="lg">
      <v-form v-model="form" @submit.prevent="onSubmit">
        <div class="text-subtitle-1 text-medium-emphasis">Account</div>

        <v-text-field
          v-model="enterEmail"
          :readonly="loading"
          :rules="[required]"
          class="mb-2"
          clearable
          label="User Name"
          prepend-inner-icon="mdi-account-outline"
        ></v-text-field>

        <div class="text-subtitle-1 text-medium-emphasis d-flex align-center justify-space-between">
          Password

          <a
            class="text-caption text-decoration-none text-blue"
            href="#"
            rel="noopener noreferrer"
            target="_blank"
          >
            Forgot login password?</a
          >
        </div>

        <v-text-field
          v-model="enterPassword"
          :append-inner-icon="visible ? 'mdi-eye-off' : 'mdi-eye'"
          :type="visible ? 'text' : 'password'"
          :readonly="loading"
          :rules="[required]"
          clearable
          label="Password"
          placeholder="Enter your password"
          prepend-inner-icon="mdi-lock-outline"
          @click:append-inner="visible = !visible"
        ></v-text-field>

        <v-card class="mb-12" color="surface-variant" variant="tonal">
          <v-card-text class="text-medium-emphasis text-caption">
            Status : UserName= Krit Password = pass1234 rank= พนักงาน Status : UserName= nattacha
            Password = happy123 rank= ผู้จัดการ
          </v-card-text>
        </v-card>

        <v-btn
          :disabled="!form"
          :loading="loading"
          block
          class="mb-8"
          type="submit"
          color="blue"
          size="large"
          variant="tonal"
        >
          Log In
        </v-btn>
      </v-form>
    </v-card>
    {{ userStore.currentUser ? userStore.currentUser?.name : 'ไม่พบผู้ใช้' }}
  </div>
</template>

<style scoped>
.background-image {
  position: relative;
  top: 50px;
  left: 0%;
  width: 100%;
  height: 100%;
  object-fit: cover;
  z-index: 2;
}

.login-card {
  position: relative;
  z-index: -1;
}
</style>
